#ifndef BACK_CONSTS_H
#define BACK_CONSTS_H

typedef struct imgs {
    int len; 
    SDL_Texture** arr;
} imgs ;

typedef struct array {
    int* arr ;
    int len ;
} array ;

typedef enum cardinal {NORTH, SOUTH, EAST, WEST} cardinal ;

extern Grid map ;

extern int zoom ;

extern int render_distance ;

extern double speed ;
extern int precision ;

extern double epsilon_x ;
extern double epsilon_y ;
// are in [0.0, 1.0[

extern int player_x ;
extern int player_y ;
// are in [|0, 8[|

extern int player_cx ;
extern int player_cy ;
// any integer

extern int draw_par ;

extern int __width__ ;
extern int __height__ ;

extern template* configs ;
extern array** matches ;    // first length is always 4 (NESW)
extern int n_configs ;      // 2nd length

extern imgs digits ;
extern imgs letters ;

/* example
[
    [
        [1, 3], [0], [3], [2] <-- this 1 means "config 1 can be placed above a chunk with config 0"
    ],
    [
        [1], [0], [3], [0, 2] <-- this (1st) 0 means "config 0 can be placed below a chunk with config 1"
    ],
    [
        [1], [], [], []
    ],
    [
        [1], [0], [], []
    ]
]
*/

// chunk is 8x8 and (0, 0) is at top left

#endif